Codeforces Round #441 (Div. 2, by Moscow Team Olympiad) E. National Property(2-sat)

E. National Property
time limit per test
1 second
memory limit per test
512 megabytes
input
standard input
output
standard output

You all know that the Library of Bookland is the largest library in the world. There are dozens of thousands of books in the library.

Some long and uninteresting story was removed...

The alphabet of Bookland is so large that its letters are denoted by positive integers. Each letter can be small or large, the large version of a letter x is denoted by x'. BSCII encoding, which is used everywhere in Bookland, is made in that way so that large letters are presented in the order of the numbers they are denoted by, and small letters are presented in the order of the numbers they are denoted by, but all large letters are before all small letters. For example, the following conditions hold: 2 < 3, 2' < 3', 3' < 2.

A word x1, x2, ..., xa is not lexicographically greater than y1, y2, ..., yb if one of the two following conditions holds:

  • a ≤ b and x1 = y1, ..., xa = ya, i.e. the first word is the prefix of the second word;
  • there is a position 1 ≤ j ≤ min(a, b), such that x1 = y1, ..., xj - 1 = yj - 1 and xj < yj, i.e. at the first position where the words differ the first word has a smaller letter than the second word has.

For example, the word "3' 5" is before the word "4' 6" in lexicographical order. It is said that sequence of words is in lexicographical order if each word is not lexicographically greater than the next word in the sequence.

Denis has a sequence of words consisting of small letters only. He wants to change some letters to large (let's call this process a capitalization) in such a way that the sequence of words is in lexicographical order. However, he soon realized that for some reason he can't change a single letter in a single word. He only can choose a letter and change all of its occurrences in all words to large letters. He can perform this operation any number of times with arbitrary letters of Bookland's alphabet.

Help Denis to choose which letters he needs to capitalize (make large) in order to make the sequence of words lexicographically ordered, or determine that it is impossible.

Note that some words can be equal.

Input

The first line contains two integers n and m (2 ≤ n ≤ 100 000, 1 ≤ m ≤ 100 000) — the number of words and the number of letters in Bookland's alphabet, respectively. The letters of Bookland's alphabet are denoted by integers from 1 to m.

Each of the next n lines contains a description of one word in format li, si, 1, si, 2, ..., si, li (1 ≤ li ≤ 100 000, 1 ≤ si, j ≤ m), where li is the length of the word, and si, j is the sequence of letters in the word. The words are given in the order Denis has them in the sequence.

It is guaranteed that the total length of all words is not greater than 100 000.

Output

In the first line print "Yes" (without quotes), if it is possible to capitalize some set of letters in such a way that the sequence of words becomes lexicographically ordered. Otherwise, print "No" (without quotes).

If the required is possible, in the second line print k — the number of letters Denis has to capitalize (make large), and in the third line print kdistinct integers — these letters. Note that you don't need to minimize the value k.

You can print the letters in any order. If there are multiple answers, print any of them.

Examples
input
4 3
1 2
1 1
3 1 3 2
2 1 1
output
Yes
2
2 3
input
6 5
2 1 2
2 1 2
3 1 2 3
2 1 5
2 4 4
2 4 4
output
Yes
0
input
4 3
4 3 2 2 1
3 1 1 3
3 2 3 3
2 3 1
output
No
Note

In the first example after Denis makes letters 2 and 3 large, the sequence looks like the following:

  • 2'
  • 1
  • 3' 2'
  • 1

The condition 2' < 1 holds, so the first word is not lexicographically larger than the second word. The second word is the prefix of the third word, so the are in lexicographical order. As the first letters of the third and the fourth words are the same, and 3' < 1, then the third word is not lexicographically larger than the fourth word.

In the second example the words are in lexicographical order from the beginning, so Denis can do nothing.

【题意】对于一个数字如3,那么3'<3,且加了'的数均小于没有加'的数,对于两个加了'的数,按照没有'时的规则比较大小,问存不存在一种修改方案将给定的一系列打次化为字典序递增的。

【分析】2-sat,详细见代码。建图请看这里

以下为要求输出字典序最小的模板。

 

#include <bits/stdc++.h>
#define inf 0x3f3f3f3f
#define met(a,b) memset(a,b,sizeof a)
#define pb push_back
#define mp make_pair
#define rep(i,l,r) for(int i=(l);i<=(r);++i)
#define inf 0x3f3f3f3f
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
const int N = 2e5+50;;
const int M = 255;
const int mod = 998244353;
const int mo=123;
const double pi= acos(-1.0);
typedef pair<int,int>pii;
typedef pair<ll,int>P;
vector<int>vec[N],ans;
struct Edge {
    int to,next;
} edge[M];
int head[M],tot;
void init() {
    tot = 0;
    memset(head,-1,sizeof(head));
}
void addedge(int u,int v) {
    //printf("!!!%d %d\n",u,v);
    edge[tot].to = v;
    edge[tot].next = head[u];
    head[u] = tot++;
}
bool vis[N];//染色标记,为true表示选择
int S[N],top;//
bool dfs(int u) {
    if(vis[u^1])return false;
    if(vis[u])return true;
    vis[u] = true;
    S[top++] = u;
    for(int i = head[u]; i != -1; i = edge[i].next)
        if(!dfs(edge[i].to))
            return false;
    return true;
}
bool Twosat(int n) {
    memset(vis,false,sizeof(vis));
    for(int i = 0; i < n; i += 2) {
        if(vis[i] || vis[i^1])continue;
        top = 0;
        if(!dfs(i)) {
            while(top)vis[S[--top]] = false;
            if(!dfs(i^1)) return false;
        }
    }
    return true;
}
int main() {
    int n,m;
    int u,v;
    scanf("%d%d",&n,&m);
    init();
    for(int i=1,s,x;i<=n;i++){
        scanf("%d",&s);
        while(s--){
            scanf("%d",&x);
            vec[i].pb(x);
        }
        if(i==1)continue;
        int len=min(vec[i].size(),vec[i-1].size());
        int pos=-1;
        for(int j=0;j<len;j++){
            if(vec[i][j]!=vec[i-1][j]){
                pos=j;break;
            }
        }
        if(pos==-1){
            if(vec[i-1].size()>vec[i].size()){
                return puts("No")*0;
            }
        }
        else {
            int a=vec[i-1][pos],b=vec[i][pos];
            if(a>b){
                addedge(2*a-1,2*a-2);
                addedge(2*b-2,2*b-1);
            }
            else {
                addedge(2*a-1,2*b-1);
                addedge(2*b-2,2*a-2);
            }
        }
    }
    if(Twosat(2*m)) {
        puts("Yes");
        for(int i = 0; i < 2*m; i+=2)
            if(vis[i])
                ans.pb((i)/2+1);
       printf("%d\n",ans.size());
       for(int x : ans)printf("%d ",x);
    } else printf("No\n");
    return 0;
}

 输出任意一组解。

#include <bits/stdc++.h>

using namespace std;

typedef long long LL;

const int maxn=200005;
const int maxm=2000005;

struct qlt
{
    int n,num1;
    int b[maxn],next[maxm],a[maxm];
    int dfn[maxn],low[maxn];
    int stack[maxn],belong[maxn];
    bool instack[maxn];
    int num[maxn],topo[maxn];
    int sum2;
    int scc,top,index;
    vector<int> v[maxn];
    void init(int nn)
    {
        n=nn;num1=0;
        memset(b,0,sizeof(b));
    }
    void addedge(int x,int y)
    {
        ++num1;a[num1]=y;next[num1]=b[x];b[x]=num1;
    }
    void tarjan(int x)
    {
        int y;
        low[x]=dfn[x]=++index;
        stack[top++]=x;
        instack[x]=true;
        for (int i=b[x];i>0;i=next[i])
        {
            y=a[i];
            if (!dfn[y])
            {
                tarjan(y);
                if (low[x]>low[y]) low[x]=low[y];
            }
            else if (instack[y]&&low[x]>dfn[y])
                low[x]=dfn[y];
        }
        if (low[x]==dfn[x])
        {
            scc++;
            do
            {
                y=stack[--top];
                instack[y]=false;
                belong[y]=scc;
                v[scc].push_back(y);
                sum2++;
                topo[y]=sum2;
                num[scc]++;
            }
            while (y!=x);
        }
    }
    void solve()
    {
        memset(dfn,0,sizeof(dfn));
        memset(instack,false,sizeof(instack));
        memset(num,0,sizeof(num));
        index=scc=top=sum2=0;
        for (int i=0;i<n;++i)
            if (!dfn[i]) tarjan(i);
    }
}mp;

int n,m,nn,x;
vector<int> v[maxn],vv;

int main()
{
    scanf("%d%d",&n,&m);
    mp.init(2*m);
    for (int i=1;i<=n;++i)
    {
        scanf("%d",&nn);
        while (nn--)
        {
            scanf("%d",&x);
            v[i].push_back(x);
        }
        if (i==1) continue;
        int len=min(v[i-1].size(),v[i].size());
        int pos=-1;
        for (int j=0;j<len;++j)
        {
            if (v[i][j]!=v[i-1][j])
            {
                pos=j;
                break;
            }
        }
        if (pos==-1)
        {
            if (v[i].size()<v[i-1].size())
            {
                printf("No\n");
                return 0;
            }
        }
        else
        {
            int a=v[i-1][pos],b=v[i][pos];
            //if (a==b) continue;
            a--;b--;
            if (a>b)
            {
                mp.addedge(2*a+1,2*a);
                mp.addedge(2*b,2*b+1);
            }
            else
            {
                mp.addedge(2*a+1,2*b+1);
                mp.addedge(2*b,2*a);
            }
        }
    }
    mp.solve();
    for (int i=0;i<m;++i)
    {
        if (mp.belong[2*i]==mp.belong[2*i+1])
        {
            printf("No\n");
            return 0;
        }
    }
    vv.clear();
    for (int i=0;i<m;++i) if (mp.topo[2*i]<mp.topo[2*i+1]) vv.push_back(i+1);
    printf("Yes\n");
    printf("%d\n",(int)vv.size());
    for (int i=0;i<vv.size();++i) printf("%d ",vv[i]);
    return 0;
}

 

posted @ 2017-10-17 14:51  贱人方  阅读(337)  评论(0编辑  收藏  举报